#include <iostream>
#include <string>
#include <fstream>
using namespace std;

int main () {
	fstream filestr, binstr, pointerstr;
	filestr.open("lines.txt", fstream::in);
	binstr.open("lines.bin", fstream::out | fstream::binary | fstream::trunc);
	pointerstr.open("pointers.bin", fstream::out | fstream::binary | fstream::trunc);

	bool odd = false;
	bool lobyte = true;
	char hibyte = '\x90';
	string str;
	while (!filestr.eof()) {
		getline(filestr, str);

		odd = !odd;
		if (odd) {
			if (str.size() == 0 || str[0] == '*') {
				pointerstr.put('\x00');
				pointerstr.put('\x90');
				getline(filestr, str);
				odd = false;
				continue;
			}
			if (lobyte) {
				pointerstr.put('\x80');
				pointerstr.put(hibyte++);
				lobyte = false;
			}
			else {
				pointerstr.put('\x00');
				pointerstr.put(hibyte);
				lobyte = true;
			}
		}

		bool eol = false;
		char bin[64];
		for (int i = 0; i < 32; i++) {
			if (!eol) {
				if (str.size() - i >= 3 && str[i] == 'Z' && str[i+1] == 'D' && str[i+2] == ':') {
					bin[i+i] = '\x20';
					bin[i+i+1] = '\x24';
					bin[i+i+2] = '\x21';
					bin[i+i+3] = '\x24';
					bin[i+i+4] = '\x22';
					bin[i+i+5] = '\x24';
					i += 2;
					continue;
				}
				if (str.size() - i >= 4 && str[i] == 'A' && str[i+1] == 'G' && str[i+2] == 'I' && str[i+3] == ':') {
					bin[i+i] = '\x23';
					bin[i+i+1] = '\x24';
					bin[i+i+2] = '\x24';
					bin[i+i+3] = '\x24';
					bin[i+i+4] = '\x25';
					bin[i+i+5] = '\x24';
					bin[i+i+6] = '\x2F';
					bin[i+i+7] = '\x24';
					i += 3;
					continue;
				}
				if (str.size() - i >= 3 && str[i] == 'F' && str[i+1] == 'T' && str[i+2] == ':') {
					bin[i+i] = '\x26';
					bin[i+i+1] = '\x24';
					bin[i+i+2] = '\x27';
					bin[i+i+3] = '\x24';
					bin[i+i+4] = '\x28';
					bin[i+i+5] = '\x24';
					i += 2;
					continue;
				}
				if (str.size() - i >= 4 && str[i] == 'S' && str[i+1] == 'L' && str[i+2] == 'D' && str[i+3] == ':') {
					bin[i+i] = '\x2D';
					bin[i+i+1] = '\x24';
					bin[i+i+2] = '\x21';
					bin[i+i+3] = '\x24';
					bin[i+i+4] = '\x31';
					bin[i+i+5] = '\x24';
					bin[i+i+6] = '\x2E';
					bin[i+i+7] = '\x24';
					i += 3;
					continue;
				}
				if (str.size() - i >= 4 && str[i] == 'P' && str[i+1] == 'R' && str[i+2] == 'I' && str[i+3] == ':') {
					bin[i+i] = '\x30';
					bin[i+i+1] = '\x24';
					bin[i+i+2] = '\x31';
					bin[i+i+3] = '\x24';
					bin[i+i+4] = '\x32';
					bin[i+i+5] = '\x24';
					bin[i+i+6] = '\x28';
					bin[i+i+7] = '\x24';
					i += 3;
					continue;
				}

				if (i >= str.size()) eol = true;
				else if ('A' <= str[i] && str[i] <= 'Z') bin[i+i] = str[i] - 'A';
				else if ('a' <= str[i] && str[i] <= 'z') bin[i+i] = str[i] - 'a';
				else if ('0' <= str[i] && str[i] <= '9') bin[i+i] = str[i] - '0' + '\x90';
				else switch (str[i]) {
					case '.': bin[i+i] = '\x1A'; break;
					case ',': bin[i+i] = '\x1B'; break;
					case '\'': case '': case '`': case '': case '': bin[i+i] = '\x1C'; break;
					case ':': bin[i+i] = '\x1D'; break;
					case '!': bin[i+i] = '\x1E'; break;
					case ' ': bin[i+i] = '\x1F'; break;
					case '-': bin[i+i] = '\x3F'; break;
					case '\?': bin[i+i] = '\x2A'; bin[i+i+1] = '\x25'; continue;
					default: eol = true;
				}
			}
	 		if (eol) bin[i+i] = '\x1F';
			bin[i+i+1] = '\x24';
		}

		binstr.write(bin, 64);
	}

	filestr.close();
	binstr.close();
	pointerstr.close();

	return 0;
}